#INCLUDE "ac_htmldoc.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_ac_htmldoc",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_ac_htmldoc_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_ac_htmldoc_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _ac_htmldoc AS _pdm_PlugIn && 
   Name="_ac_htmldoc"

   ID=30001         && ID of Plug-in
   Type="CONV" && Typ of plug-in (group)

   Setting=.NULL.
   Par=.NULL.


   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetOutputFile(loSetting,laFile) && Return main output file
      * loSetting - Object of settings
      *@laFile    - Output file (it's array)
      LOCAL loPDM,lcbook
      loPDM=EVAL(This.PDM)

      lcbook=loSetting.book
      IF !EMPTY(lcbook)
         lcbook=IIF(AT("\\",lcbook)>0 OR AT(":",lcbook)>0,"",loPDM.OutDir)+lcbook
      ENDIF
      laFile(1)=ChangeExtensionFromFile(m.lcbook,'pdf')
      RETURN 1
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\ac_"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "HTMLDOC")

         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetbook, "Book file")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetDOC, "HTMLDOC EXE")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Plug-in for converting html files to pdf file. htmldoc (http://www.easysw.com/htmldoc/) is host application.])


         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lcFiles,luCatch,;
            lcbook,lcPom,lcLang,lcPom,lii,liDSIS,;
            lcDir,lcStartupInfo,lcProcessInfo,loSI,loPI

      LOCAL ARRAY laFiles(1)

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      liDSIS=This.DataSessionID

      * book - folder and name of project
      STORE 0 TO lihbook
      lcbook=loSetting.book

      IF !EMPTY(lcbook)
         lcbook=IIF(AT("\\",lcbook)>0 OR AT(":",lcbook)>0,"",loPDM.OutDir)+lcbook
      ENDIF

      IF !EMPTY(lcbook)
         SET COLLATE TO "MACHINE"
         SET DATASESSION TO (loPDMs.DataSessionID)
         SELE (loPDMs.LangC) && sko na seznam jazyk a nastav jazykov kontext
         lcLang="0x"+RIGHT(TRANSFORM(GetThreadLocale(),"@0"),4)+IIF(SEEK(GetThreadLocale())," "+ALLT(Name),"")

         SET COLLATE TO (loPDMs.Collate)
         lcPom=STRTRAN(loSetting.cBook,"%PDF%",ChangeExtensionFromFile(ExtractFileFromFile(lcbook),'pdf'))
         lcPom=STRTRAN(lcPom,"%CP%",LTRIM(STR(loPDMs.CP,6)))

         lcFiles=""
         SET DATASESSION TO (loPDM.DataSessionID)
         SELE (loPDM.FL)
         SCAN FOR !BITTEST(XX505,0) AND !BITTEST(XX505,1) AND !EMPTY(XX510) && All files, exception frames, GUI 
              lcFiles=lcFiles+loPDM.PathRelativePathTo(lcbook,loPDM.OutDir+XX510)+CRLF
         ENDSCAN
         lcPom=STRTRAN(lcPom,"%files%",lcFiles)

         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         =STRTOFILE(lcPom,lcbook)
         =IIF(loPDMs.nErr=0,.T.,;
             loPDMs.WriteToLogFile(STRTRAN(This.GetString(_PDM_msgFileNC),"%File%",lcbook)))
         =loPDMs.SetCatch(luCatch) && Nastav zachycen chyby
      ENDIF

      SET DATASESSION TO (liDSIS)


*!*	      IF loSetting.iRunhtmldoc=1 AND !EMPTY(loSetting.htmldoc) AND FILE(loSetting.htmldoc)
*!*	         lcDir=loPDM.OutDir+CHR(0)

*!*	         loSI=CREATEOBJECT("_struc_STARTUPINFO")
*!*	         loPI=CREATEOBJECT("_struc_PROCESS_INFORMATION")

*!*	         lcStartupInfo=loSI.CreateString()
*!*	         lcProcessInfo=loPI.CreateString()

*!*	         IF CreateProcess(.NULL., loSetting.htmldoc, 0, 0, 1,  NORMAL_PRIORITY_CLASS, 0, @lcDir, @lcStartupInfo, @lcProcessInfo)#0
*!*	            * vborn neselhalo to
*!*	            loPI.ReadString(@lcProcessInfo)
*!*	            liWFS=WAIT_TIMEOUT
*!*	            DO WHILE liWFS= WAIT_TIMEOUT
*!*	               liWFS=WaitForSingleObject(loPI.hProcess, 250 )
*!*	            ENDDO
*!*	            =CloseHandle(loPI.hProcess) && uzavi handle
*!*	         ENDIF
*!*	      ENDIF
      RETURN ""
   ENDPROC


   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_ac_htmldoc_par")
   ENDPROC


   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.book=GetINIString(lcSection,"BOOK",loSettings.book,254,@lcFile)
      loSettings.irunhtmldoc=VAL(GetINIString(lcSection,"IRUNHTMLDOC",STR(loSettings.irunhtmldoc,1),1,@lcFile))
      loSettings.htmldoc=GetINIString(lcSection,"HTMLDOC",loSettings.htmldoc,254,@lcFile)
      lcData=GetINISection(lcSection+"_Default",32000,@lcFile) && Cel sekce
      IF !EMPTY(lcData)
         liCount=ALINES(laPom,STRTRAN(lcData,CHR(0),CHR(13)+CHR(10))) && Nati dky
         lcData=""
         FOR lii=1 TO liCount
             lcData=lcData+SUBST(laPom(lii),2)+CHR(13)+CHR(10)
         NEXT
         IF !EMPTY(lcData)
            loSettings.cbook=lcData
         ENDIF
      ENDIF

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"BOOK",ALLT(loSettings.book),@lcFile)
      =WriteINIString(lcSection,"IRUNHTMLDOC",STR(loSettings.irunhtmldoc,1),@lcFile)
      =WriteINIString(lcSection,"HTMLDOC",ALLT(loSettings.htmldoc),@lcFile)

      lcData=""
      liCount=ALINES(laPom,loSettings.cbook) && Nati dky
      FOR lii=1 TO liCount
          lcData=lcData+"="+laPom(lii)+CHR(0)
      NEXT
      =WriteINISection(lcSection+"_Default",@lcData,@lcFile)

      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object
      loDst.book=loSrc.book
      loDst.cbook=loSrc.cbook
      loDst.irunhtmldoc=loSrc.irunhtmldoc
      loDst.htmldoc=loSrc.htmldoc
   ENDPROC


   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody
      RETURN .T.
   ENDPROC

ENDDEFINE

****************************************************************
DEFINE CLASS _ac_htmldoc_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_ac_htmldoc_par"
   OK=.F.
 
   book="test.book" && HTMLDOC project

   irunhtmldoc=0 && Run compile HTML Help Wokshop
   htmldoc="" && HTML Help Wokshop EXE

   cbook="" && Default contents of book file

   PROCEDURE Init()
      This.cbook=;
          "#HTMLDOC 1.8.23"+CRLF+;
          "-t pdf14"+;
          " -f %PDF%"+;
          " --book --toclevels 4 --no-numbered"+;
          [ --toctitle "Table of Contents"]+;
          " --title --linkstyle underline --size Universal"+;
          " --left 1.00in --right 0.50in --top 0.50in --bottom 0.50in"+;
          " --header .t. --footer h.1 --nup 1 --tocheader .t. --tocfooter ..i"+;
          " --portrait --color --no-pscommands --no-xrxcomments"+;
          " --compression=1 --jpeg=0 --fontsize 11.0 --fontspacing 1.2"+;
          " --headingfont Helvetica"+;
          " --bodyfont Times"+;
          " --headfootsize 11.0"+;
          " --headfootfont Helvetica"+;
          " --charset cp-%CP%"+;
          " --links --embedfonts"+;
          " --pagemode outline --pagelayout single"+;
          " --firstpage c1 --pageeffect none"+;
          " --pageduration 10 --effectduration 1.0"+;
          " --no-encryption --permissions all"+;
          [  --owner-password ""  --user-password ""]+;
          [ --browserwidth 1024]+CRLF+;
          [%files%]
   ENDPROC

ENDDEFINE

