**************************************************************************
** Program name: PRGAn.PRG
** Version: 0.0.1
** Create date: 2002-01-25
** Description: General procedures for analyzing source code
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** CP: 1250

#INCLUDE "prgan.h"

*************************************
* Provede parsovn dku zdrojovho kdu
*************************************
PROCEDURE ParseRowSC(lcRow,llPRC,liFlags,lcName, lcParams,lcClass,lcClassLib)
* @lcRow       - dek, kter se m otestovat
*  llPRC       - Pznak, zda je pedvan dek uvnit metody/procedury
* @liFlags     - Pznaky metody/udlosti/objektu
* @lcName      - Sem vrt nzev procedury/funkce/objektu
* @lcParams    - Sem se vrt seznam parametr (funkce), nebo seznam vlastnost (seznam vlastnost/objek)
* @lcClass     - Sem se vrt nzev tdy child objektu
* @lcClassLib  - Sem se vrt nzev knihovny

* Popis pznak liFlags
*  0. Bit - PROTECTED 
*  1. Bit - HIDDEN
*  2. Bit - PROCEDURE
*  3. Bit - FUNCTION
*  4. Bit - PROPERTIES
*  5. Bit - OBJECT
*  6. Bit - ARRAY
*  7. Bit - OF (Class)
*  8. Bit - OLEPUBLIC (Class)
*  9. Bit - NONIT (Only object)
*x10. Bit - ONLY Comment
* 11. Bit - Class
* 12. Bit - End Proced
* 13. Bit - End Class
* 14. Bit - Include
* 15. Bit - SET PROCED TO
* 16. Bit - SET CLASSLIB TO

* 17. Bit - DO FORM ???? NAME
* 18. Bit - REPORT FORM ??? xxxx
* 19. Bit - LABEL FORM  ???? xxxx
* 20. Bit - DO [procedure]  xxxxx
* 21. Bit - USE [table]  xxxxx
* 22. Bit - OPEN DATA [database]  xxxxx
* 23. Bit - DECLARE ... [name] IN [lib]

* 24. Bit - WITH  [name] AS [class] OF [lib]
* 25. Bit - #IF
* 26. Bit - #ENDIF
* 27. Bit - TEXT
* 28. Bit - ENDTEXT


LOCAL lii,liy,liParams,liEnd,liComment,liLen,liz,liDal,lcPom
STORE LEN(m.lcRow) TO liEnd,liLen && Dlka celho dku

*lii=AT_NonSpace(@lcRow,1) && najdi prvn znak
lii=AT_NonSpaceEx(@lcRow,1,liLen) && najdi prvn znak
lii=IIF(m.lii=0,1,m.lii)

liFlags=0 && Resetuj pznak metody/udlosti (!!! VDY !!!)
STORE "" TO lcName, lcParams,lcClass,lcClassLib

* Nyn mus probhnout test na kle PROTECTED a HIDDEN
IF  (LOWER(SUBS(m.lcRow,m.lii,5))== "prot ";
    OR LOWER(SUBS(m.lcRow,m.lii,6))== "prote ";
    OR LOWER(SUBS(m.lcRow,m.lii,7))== "protec ";
    OR LOWER(SUBS(m.lcRow,m.lii,8))== "protect ";
    OR LOWER(SUBS(m.lcRow,m.lii,9))== "protecte ";
    OR LOWER(SUBS(m.lcRow,m.lii,10))=="protected ";
    OR LOWER(SUBS(m.lcRow,m.lii,5))== "hidd ";
    OR LOWER(SUBS(m.lcRow,m.lii,6))== "hidde ";
    OR LOWER(SUBS(m.lcRow,m.lii,7))== "hidden ";
    )
   * Nastav pznak PROTECTED/HIDDEN
   liFlags=IIF(LOWER(SUBS(m.lcRow,m.lii,1))=="p",_Flags_Protected,_Flags_Hidden)
*   lii=AT_Space(@lcRow,lii+4) && najdi prvn mezeru
*   lii=AT_NonSpace(@lcRow,lii) && najdi prvn znak
   lii=AT_Word(@lcRow,m.lii+4)
ENDIF


* Pokud to nen tento text (proc,proce,proced, ...), pak je to seznam vlastnost (bylo-li protec/hidden)
IF LOWER(SUBS(m.lcRow,m.lii,5))== "proc " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "proce " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "proced " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "procedu " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "procedur " OR ;
   LOWER(SUBS(m.lcRow,m.lii,10))=="procedure " OR ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "func " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "funct " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "functi " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "functio " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "function "

   liFlags=IIF(LOWER(SUBS(m.lcRow,m.lii,1))=="p",BITSET(m.liFlags,2),BITSET(m.liFlags,3))

   lii=AT_Word(@lcRow,m.lii+4)

   * Pak tam me bt (
   lcPom="("
   STORE AT_ExEx(@lcRow,@lcPom,m.lii,m.liEnd) TO liy,liParams && Pokus se najt zvorku

   liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
   lcName=STRTRAN(STRTRAN(SUBS(m.lcRow,m.lii,m.liy-m.lii)," ",""),CHR(9),"") && Nzev procedury/funkce/metody

   * Nyn zjisti seznam parametr procedury, pokud jsou
   IF liParams>0
      liParams=m.liParams+1
      liy=AT_Ex(@lcRow,")",m.liParams,m.liEnd) && Pokus se najt pravou zvorku
      lcParams=SUBS(m.lcRow,m.liParams,m.liy-m.liParams)
   ENDIF
   RETURN .T.
ENDIF

* Pro seznam matic vra samotn seznam
IF (m.liFlags=0 AND !m.llPRC AND (;
     LOWER(SUBS(m.lcRow,m.lii,5))== "dime " OR ;
     LOWER(SUBS(m.lcRow,m.lii,6))== "dimen " OR ;
     LOWER(SUBS(m.lcRow,m.lii,7))== "dimens " OR ;
     LOWER(SUBS(m.lcRow,m.lii,8))== "dimensi " OR ;
     LOWER(SUBS(m.lcRow,m.lii,9))== "dimensio " OR ;
     LOWER(SUBS(m.lcRow,m.lii,10))== "dimension " OR ;
     ((LOWER(SUBS(m.lcRow,m.lii,5))== "decl " OR ;
     LOWER(SUBS(m.lcRow,m.lii,6))== "decla " OR ;
     LOWER(SUBS(m.lcRow,m.lii,7))== "declar " OR ;
     LOWER(SUBS(m.lcRow,m.lii,8))== "declare ") AND ATC(" in ",LOWER(SUBS(m.lcRow,m.lii)))=0));
     ) OR ;
   ((BITTEST(m.liFlags,0) OR BITTEST(m.liFlags,1)) AND (;
     LOWER(SUBS(m.lcRow,m.lii,5))== "arra " OR ;
     LOWER(SUBS(m.lcRow,m.lii,6))== "array "))

   lii=AT_Word(@lcRow,m.lii+4)

   liFlags=BITSET(m.liFlags,6) && Matice
   lcParams=CHRTRAN(SUBS(m.lcRow,m.lii)," "+CHR(9),"")
            
   RETURN .T.
ENDIF


* Pro seznam vlastnost vra samotn seznam
IF BITTEST(m.liFlags,0) OR BITTEST(m.liFlags,1)
   liFlags=BITSET(m.liFlags,4) && Properties
   lcParams=CHRTRAN(SUBS(m.lcRow,m.lii)," "+CHR(9),"")
   RETURN .T.
ENDIF

* Zatm nic nenael
* pak to otestuj, zda tam nen objekt
IF m.liFlags=0 AND (LOWER(SUBS(m.lcRow,m.lii,4))== "add ")
   lii=AT_NonSpaceEx(@lcRow,m.lii+4,liEnd) && najdi prvn znak

   IF LOWER(SUBS(m.lcRow,m.lii,5))== "obje " OR ;
      LOWER(SUBS(m.lcRow,m.lii,6))== "objec " OR ;
      LOWER(SUBS(m.lcRow,m.lii,7))== "object "

      * Test na objekt - ADD OBJExCT [PROTxECTED/HIDDxEN] name AS class [NOINxIT] [WITH left=5, top=1,...]
      
      * Nastav pznak OBJECT
      liFlags=BITSET(m.liFlags,5)

      * Hledej zda je to PROTECTED nebo HIDDEN
      lii=AT_Word(@lcRow,m.lii+4)

      * Nastav pznak PROTECTED/HIDDEN
      * pokud to nen tento text (proc,proce,proced, ...)
      IF LOWER(SUBS(m.lcRow,m.lii,5))== "prot " OR ;
               LOWER(SUBS(m.lcRow,m.lii,6))== "prote " OR ;
               LOWER(SUBS(m.lcRow,m.lii,7))== "protec " OR ;
               LOWER(SUBS(m.lcRow,m.lii,8))== "protect " OR ;
               LOWER(SUBS(m.lcRow,m.lii,9))== "protecte " OR ;
               LOWER(SUBS(m.lcRow,m.lii,10))=="protected "
               
         liFlags=BITSET(m.liFlags,0)

         lii=AT_Word(@lcRow,m.lii+4)
      ENDIF

      * Nyn by zde ml bt nzev objektu
      liy=AT_SpaceEx(@lcRow,m.lii+1,liEnd) && najdi prvn mezeru

      lcName=SUBS(m.lcRow,m.lii,m.liy-m.lii) && Nati nzev objektu
      lii=AT_NonSpaceEx(@lcRow,m.liy+1,liEnd) && najdi prvn znak

      IF !LOWER(SUBST(m.lcRow,m.lii,3))=="as "
         * Intern chyba, chyb klov slovo AS
         RETURN .F.
      ENDIF
      lii=AT_NonSpaceEx(@lcRow,m.lii+3,liEnd) && najdi prvn znak

      * Nyn by zde ml bt nzev tdy
      STORE AT_SpaceEx(@lcRow,m.lii+1,liEnd) TO liDal,liy && najdi prvn mezeru
      liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)

      lcClass=SUBS(m.lcRow,m.lii,m.liy-m.lii) && Nati nzev tdy
      IF m.liDal>0
         lii=AT_NonSpaceEx(@lcRow,m.liy+1,liEnd) && najdi prvn znak
         * Nyn me bt klov slovo NOINxIT 
         IF LOWER(SUBS(m.lcRow,m.lii,5))== "noin " OR ;
            LOWER(SUBS(m.lcRow,m.lii,6))== "noini " OR ;
            LOWER(SUBS(m.lcRow,m.lii,7))== "noinit "
 
            liFlags=BITSET(m.liFlags,9)
            lii=AT_Word(@lcRow,m.lii+4)
         ENDIF

         * Take by tam mohlo bt klov slovo WITH a seznam vlastnost
         IF LOWER(SUBS(m.lcRow,m.lii,5))== "with "
            lcParams=SUBS(m.lcRow,m.lii+5)
         ENDIF
      ENDIF
      RETURN .T.
   ENDIF
ENDIF

* Otestuj, zda to nen definice tdy
IF m.liFlags=0 AND (LOWER(SUBS(m.lcRow,m.lii,5))=="defi " OR;
   LOWER(SUBS(m.lcRow,m.lii,6))=="defin " OR;
   LOWER(SUBS(m.lcRow,m.lii,7))=="define ")
   * Nzev tdy
   lii=AT_SpaceEx(@lcRow,m.lii+4,liEnd) && najdi prvn mezeru
   lii=AT_NonSpaceEx(@lcRow,m.lii,liEnd) && najdi prvn znak po mezee
   IF !LOWER(SUBS(m.lcRow,m.lii,4))=="clas" && pokud to nen tento text
      RETURN .F. && pak vypadni
   ENDIF
   liFlags=BITSET(m.liFlags,11)

   lii=AT_Word(@lcRow,m.lii+4)

   STORE AT_SpaceEx(@lcRow,m.lii,liEnd) TO liy,liDal && najdi prvn mezeru (pokud nenael, pak je na konci)
   liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
   lcName=SUBS(m.lcRow,m.lii,m.liy-m.lii)

   IF liDal>0
      * Vchoz tda
      lii=AT_NonSpaceEx(@lcRow,m.liy,liEnd) && najdi prvn znak po mezee (Najdi AS)
      lii=AT_SpaceEx(@lcRow,m.lii+2,liEnd) && najdi prvn mezeru ( za AS)

      lii=AT_NonSpaceEx(@lcRow,m.lii+1,liEnd) && najdi prvn znak po mezee (To je patrn potek nzvu tdy)
      STORE AT_SpaceEx(@lcRow,m.lii+1,liEnd) TO liy,liDal && najdi prvn mezeru 
      liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
      lcClass=SUBS(m.lcRow,m.lii,m.liy-m.lii)

      IF m.liDal>0 && Pokud tam jet nco je
         lii=AT_NonSpaceEx(@lcRow,m.liy+1,liEnd) && najdi prvn znak po mezee

         * Pozor, je tam klov slovo OF
         IF LOWER(SUBST(m.lcRow,m.lii,3))=="of "
            liFlags=BITSET(m.liFlags,7) && Nastav pznak
            lii=AT_NonSpaceEx(@lcRow,m.lii+3,liEnd) && najdi prvn znak po mezee (to bude nzev knihovny)
            STORE AT_SpaceEx(@lcRow,m.lii+1,liEnd) TO liDal,liy && najdi prvn mezeru
            liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
            lcClassLib=LOWER(SUBS(m.lcRow,m.lii,m.liy-m.lii)) && Nzev knihovny
         ENDIF
      ENDIF

      IF m.liDal>0 && Pokud tam jet nco je
         lii=AT_NonSpaceEx(@lcRow,m.liy+1,liEnd) && najdi prvn znak po mezee

         * Pozor, je tam klov slovo OLEPUBLIC
         IF LOWER(SUBST(m.lcRow,m.lii,5))=="olep " OR ;
            LOWER(SUBST(m.lcRow,m.lii,6))=="olepu " OR ;
            LOWER(SUBST(m.lcRow,m.lii,7))=="olepub " OR ;
            LOWER(SUBST(m.lcRow,m.lii,8))=="olepubl " OR ;
            LOWER(SUBST(m.lcRow,m.lii,9))=="olepubli " OR ;
            LOWER(SUBST(m.lcRow,m.lii,10))=="olepublic " OR ;
            LOWER(SUBST(m.lcRow,m.lii,4))=="olep" OR ;
            LOWER(SUBST(m.lcRow,m.lii,5))=="olepu" OR ;
            LOWER(SUBST(m.lcRow,m.lii,6))=="olepub" OR ;
            LOWER(SUBST(m.lcRow,m.lii,7))=="olepubl" OR ;
            LOWER(SUBST(m.lcRow,m.lii,8))=="olepubli" OR ;
            LOWER(SUBST(m.lcRow,m.lii,9))=="olepublic"
            liFlags=BITSET(m.liFlags,8) && Nastav pznak
         ENDIF
      ENDIF
   ENDIF
   RETURN .T.
ENDIF

* Otestuj, zda nen konec tdy
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endde " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "enddef " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "enddefi " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "enddefin " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "enddefine" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "enddefin" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "enddefi" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "enddef" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "endde")

   liFlags=BITSET(m.liFlags,13)
   RETURN .T.
ENDIF

* Pokud je to konec metody/procedury
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endpro " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endproc" OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endpro" OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endfun " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endfunc" OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endfun")
    
   liFlags=BITSET(m.liFlags,12)
   RETURN .T.
ENDIF

* Pokud je to #INCLUDE
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,6))== "#incl " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "#inclu " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "#includ " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "#include ")

   * Nyn lokalizuj soubor
   lii=AT_SpaceEx(@lcRow,m.lii+5,liEnd) && Najdi prvn mezeru
   lii=AT_NonSpaceEx(@lcRow,m.lii,liEnd) && Najdi prvn znak po mezee
   
   lcPom=SUBST(m.lcRow,m.lii,1) && Oddlova ?
   IF m.lcPom="'" OR m.lcPom="[" OR m.lcPom=["]
      liy=RAT_Ex(@lcRow,IIF(m.lcPom="[","]",m.lcPom),m.liLen,1)
      lcClassLib=SUBSTR(m.lcRow,m.lii+1,m.liy-m.lii-1)
   ELSE
      lcClassLib=SUBS(m.lcRow,m.lii)
   ENDIF
   lcClass=IIF(m.lcPom="'" OR m.lcPom="[" OR m.lcPom=["],m.lcPom,"")
   liFlags=BITSET(m.liFlags,14)
   RETURN .T.
ENDIF


* Pokud je to SET PROCED/CLASSLIB
IF m.liFlags=0 AND LOWER(SUBS(m.lcRow,m.lii,4))== "set "

   * Nyn lokalizuj soubor
   * Hledej zda je to PROCED/CLASSLIB
   lii=AT_Word(@lcRow,m.lii+3)

   * SET PROCEDURE
   IF LOWER(SUBS(m.lcRow,m.lii,5))== "proc " OR ;
      LOWER(SUBS(m.lcRow,m.lii,6))== "proce " OR ;
      LOWER(SUBS(m.lcRow,m.lii,7))== "proced " OR ;
      LOWER(SUBS(m.lcRow,m.lii,8))== "procedu " OR ;
      LOWER(SUBS(m.lcRow,m.lii,9))== "procedur " OR ;
      LOWER(SUBS(m.lcRow,m.lii,10))=="procedure "
               
      liFlags=BITSET(m.liFlags,15)
   ENDIF

   * SET CLASSLIB
   IF LOWER(SUBS(m.lcRow,m.lii,5))== "clas " OR ;
      LOWER(SUBS(m.lcRow,m.lii,6))== "class " OR ;
      LOWER(SUBS(m.lcRow,m.lii,7))== "classl " OR ;
      LOWER(SUBS(m.lcRow,m.lii,8))== "classli " OR ;
      LOWER(SUBS(m.lcRow,m.lii,9))== "classlib "
               
      liFlags=BITSET(m.liFlags,16)
   ENDIF

   IF m.liFlags#0 && hledej TO
      lii=AT_Word(@lcRow,m.lii+4)
      IF LOWER(SUBS(m.lcRow,m.lii,3))== "to " && nael
         lii=AT_Word(@lcRow,m.lii+2)
         lcClassLib=RTRIM(SUBS(m.lcRow,m.lii))
      ENDIF
   ENDIF
ENDIF

* Pokud je to DO [procedure]/ DO FORM
IF m.liFlags=0 AND LOWER(SUBS(m.lcRow,m.lii,3))== "do "
   * Nyn lokalizuj soubor
   * Hledej zda je to [procedure]/ FORM
   lii=AT_Word(@lcRow,m.lii+2)

   * DO FORM/[procedure]
   IF LOWER(SUBS(m.lcRow,m.lii,5))== "form "
      liFlags=BITSET(m.liFlags,17)
   ELSE
      * DO WHILE
      IF LOWER(SUBS(m.lcRow,m.lii,5))== "whil " OR ;
         LOWER(SUBS(m.lcRow,m.lii,6))== "while "
         liFlags=-1
      ELSE
         * DO CASE
         IF LOWER(SUBS(m.lcRow,m.lii,4))== "case"
            liFlags=-1
         ELSE
            liFlags=BITSET(m.liFlags,20)
         ENDIF
      ENDIF
   ENDIF
   IF m.liFlags>0 && hledej dl...
      IF BITTEST(m.liFlags,17) && FORM - hledej nzev formu
         liy=AT_Word(@lcRow,m.lii+4)
         lii=liy
      ENDIF
      liy=AT_Word(@lcRow,m.lii+1)
      lcClassLib=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
   ELSE
      liFlags=0
   ENDIF
ENDIF


* 19. Bit - LABEL FORM ??? xxxx
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,5))== "labe " OR;
   LOWER(SUBS(m.lcRow,m.lii,6))== "label ")

   * Nyn lokalizuj soubor
   lii=AT_Word(@lcRow,m.lii+4)

   IF LOWER(SUBS(m.lcRow,m.lii,5))== "form "
      liFlags=BITSET(m.liFlags,19)

      liy=AT_Word(@lcRow,m.lii+4)
      IF liy>0
         lii=liy
         liy=AT_Word(@lcRow,m.lii+1)
         lcClassLib=IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii))
      ENDIF
   ENDIF
ENDIF

* 18. Bit - REPORT FORM  ???? xxxx
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,5))== "repo " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "repor " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "report " )

   * Nyn lokalizuj soubor
   lii=AT_Word(@lcRow,m.lii+4)
   * DO FORM/[procedure]
   IF LOWER(SUBS(m.lcRow,m.lii,5))== "form "
      liFlags=BITSET(m.liFlags,18)
      liy=AT_Word(@lcRow,m.lii+4)
      IF liy>0
         lii=liy
         liy=AT_Word(@lcRow,m.lii+1)
         lcClassLib=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
      ENDIF
   ENDIF
ENDIF

* 22. Bit - OPEN DATA [database]  xxxxx
IF m.liFlags=0 AND ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "open "

   * Nyn lokalizuj soubor
   lii=AT_Word(@lcRow,m.lii+4)

   IF LOWER(SUBS(m.lcRow,m.lii,5))== "data "
      liFlags=BITSET(m.liFlags,22)

      liy=AT_Word(@lcRow,m.lii+4)
      IF liy>0
         lii=liy
         liy=AT_Word(@lcRow,m.lii+1)
         lcClassLib=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
      ENDIF
   ENDIF
ENDIF

* 21. Bit - USE [table]  xxxxx



* 23. Bit - DECLARE ... [name] IN [lib]
IF m.liFlags=0 AND ATC(" in ",LOWER(SUBS(m.lcRow,m.lii)))>0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,5))== "decl " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "decla " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "declar " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "declare ") 

   lii=AT_Word(@lcRow,m.lii+4) && Najdi zatek dalho slova
   liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova

   * SHORT, INTEGER, SINGLE, DOUBLE, LONG, STRING, OBJECT 
   * Pokud je to slovo z ve uvedenho seznamu
   * pak mus najt dal slovo a to bude nzev funkce
   IF INLIST(SUBST(m.lcRow,m.lii,liy-lii-1),"SHORT", "INTEGER", "SINGLE", "DOUBLE", "LONG", "STRING", "OBJECT" )
     lii=liy
     liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova
   ENDIF
   lcName=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
   lii=liy
   liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova, mlo by to bt IN

   lii=liy
   liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova, mla by to bt API knihovna
   lcClassLib=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))

   liFlags=BITSET(m.liFlags,23) && API funkce
   RETURN .T.
ENDIF


* 24. Bit - WITH  [name] AS [class] OF [lib]
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,5))== "with ") 

   lii=AT_Word(@lcRow,m.lii+4) && Najdi zatek dalho slova
   * Nzev objektu (objektov cesta)
   * (ignorovat)

   lii=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova

   * Nyn nael klov slovo AS
   IF lii>0 AND SUBST(lcRow,m.lii,3)="AS "
      lii=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova

      * Nyn by ml najt nzev tdy
      liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova

      lcName=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
      
      * Nyn dohledej knihovnu
      IF liy>0 AND SUBST(lcRow,m.liy,3)="OF "
         lii=AT_Word(@lcRow,m.liy+1) && Najdi zatek dalho slova
	     liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova
         lcClassLib=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
      ENDIF


*!*	   * Pokud je to slovo z ve uvedenho seznamu
*!*	   * pak mus najt dal slovo a to bude nzev funkce
*!*	   IF INLIST(SUBST(m.lcRow,m.lii,liy-lii-1),"SHORT", "INTEGER", "SINGLE", "DOUBLE", "LONG", "STRING", "OBJECT" )
*!*	     lii=liy
*!*	     liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova
*!*	   ENDIF
*!*	   lcName=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))
*!*	   lii=liy
*!*	   liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova, mlo by to bt IN

*!*	   lii=liy
*!*	   liy=AT_Word(@lcRow,m.lii+1) && Najdi zatek dalho slova, mla by to bt API knihovna
*!*	   lcClassLib=RTRIM(IIF(liy>0,SUBS(m.lcRow,m.lii,liy-lii-1),SUBS(m.lcRow,m.lii)))

      liFlags=BITSET(m.liFlags,24) && API funkce
   ENDIF
   RETURN .T.
ENDIF

* #IF
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,4))== "#if " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "#ifde " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "#ifdef ")
   
   liFlags=BITSET(m.liFlags,25)
   RETURN .T.
ENDIF

* TEXT
IF m.liFlags=0 AND LOWER(SUBS(m.lcRow,m.lii,4))== "text" AND EMPTY(SUBS(m.lcRow,m.lii+4,1))
   liFlags=BITSET(m.liFlags,27)
   RETURN .T.
ENDIF

* #ENDIF
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,4))== "#end" OR ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "#endi" OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "#endif")
    
   liFlags=BITSET(m.liFlags,26)
   RETURN .T.
ENDIF

* ENDTEXT
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,4))== "endt" AND EMPTY(SUBS(m.lcRow,m.lii+4,1)) OR ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "endte" AND EMPTY(SUBS(m.lcRow,m.lii+5,1)) OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endtex" AND EMPTY(SUBS(m.lcRow,m.lii+6,1)) OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endtext" AND EMPTY(SUBS(m.lcRow,m.lii+7,1)))
    
   liFlags=BITSET(m.liFlags,28)
   RETURN .T.
ENDIF

RETURN .T.

*************************************
* Provede rychl parsovn dku zdrojovho kdu
*************************************
PROCEDURE QuickParseRowSC(lcRow,llPRC,liFlags,lcName,lcParams,lcClass,lcClassLib)
* @lcRow       - dek, kter se m otestovat
*  llPRC       - Pznak, zda je pedvan dek uvnit metody/procedury
* @liFlags     - Pznaky metody/udlosti/objektu
* @lcName      - Sem vrt nzev procedury/funkce/objektu
* @lcClass     - Sem se vrt nzev tdy child objektu
* @lcClassLib  - Sem se vrt nzev knihovny

* Popis pznak liFlags
*  0. Bit - PROTECTED 
*  1. Bit - HIDDEN
*  2. Bit - PROCEDURE
*  3. Bit - FUNCTION
*  4. Bit - PROPERTIES
*  5. Bit - OBJECT
*  6. Bit - ARRAY
*  7. Bit - OF (Class)
*  8. Bit - OLEPUBLIC (Class)
*  9. Bit - NONIT (Only object)
*x10. Bit - ONLY Comment
* 11. Bit - Class
* 12. Bit - End Proced
* 13. Bit - End Class
* 14. Bit - Include

* 25. Bit - #IF
* 26. Bit - #ENDIF
* 27. Bit - TEXT
* 28. Bit - ENDTEXT

LOCAL lii,liy,liParams,liEnd,liComment,liLen,liz,liDal,lcPom
STORE LEN(m.lcRow) TO liEnd,liLen  && Dlka celho dku

*lii=AT_NonSpace(@lcRow,1) && najdi prvn znak
lii=AT_NonSpaceEx(@lcRow,1,liLen) && najdi prvn znak
lii=IIF(m.lii=0,1,m.lii)

liFlags=0 && Resetuj pznak metody/udlosti (!!! VDY !!!)
STORE "" TO lcName, lcParams,lcClass,lcClassLib

* Nyn mus probhnout test na kle PROTECTED a HIDDEN
IF  (LOWER(SUBS(m.lcRow,m.lii,5))== "prot ";
    OR LOWER(SUBS(m.lcRow,m.lii,6))== "prote ";
    OR LOWER(SUBS(m.lcRow,m.lii,7))== "protec ";
    OR LOWER(SUBS(m.lcRow,m.lii,8))== "protect ";
    OR LOWER(SUBS(m.lcRow,m.lii,9))== "protecte ";
    OR LOWER(SUBS(m.lcRow,m.lii,10))=="protected ";
    OR LOWER(SUBS(m.lcRow,m.lii,5))== "hidd ";
    OR LOWER(SUBS(m.lcRow,m.lii,6))== "hidde ";
    OR LOWER(SUBS(m.lcRow,m.lii,7))== "hidden ";
    )
   * Nastav pznak PROTECTED/HIDDEN
   liFlags=IIF(LOWER(SUBS(m.lcRow,m.lii,1))=="p",BITSET(m.liFlags,0),BITSET(m.liFlags,1))
*   lii=AT_Space(@lcRow,lii+4) && najdi prvn mezeru
*   lii=AT_NonSpace(@lcRow,lii) && najdi prvn znak
   lii=AT_Word(@lcRow,lii+4)

ENDIF


* Pokud to nen tento text (proc,proce,proced, ...), pak je to seznam vlastnost (bylo-li protec/hidden)
IF LOWER(SUBS(m.lcRow,m.lii,5))== "proc " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "proce " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "proced " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "procedu " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "procedur " OR ;
   LOWER(SUBS(m.lcRow,m.lii,10))=="procedure " OR ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "func " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "funct " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "functi " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "functio " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "function "

   liFlags=IIF(LOWER(SUBS(m.lcRow,m.lii,1))=="p",BITSET(m.liFlags,2),BITSET(m.liFlags,3))

   lii=AT_Word(@lcRow,m.lii+4)

   * Pak tam me bt (
   lcPom="("
   STORE AT_ExEx(@lcRow,@lcPom,m.lii,m.liEnd) TO liy && Pokus se najt zvorku

   liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
   lcName=STRTRAN(STRTRAN(SUBS(m.lcRow,m.lii,m.liy-m.lii)," ",""),CHR(9),"") && Nzev procedury/funkce/metody
   RETURN .T.
ENDIF

* Pro seznam matic vra samotn seznam
IF (m.liFlags=0 AND !m.llPRC AND (;
     LOWER(SUBS(m.lcRow,m.lii,5))== "dime " OR ;
     LOWER(SUBS(m.lcRow,m.lii,6))== "dimen " OR ;
     LOWER(SUBS(m.lcRow,m.lii,7))== "dimens " OR ;
     LOWER(SUBS(m.lcRow,m.lii,8))== "dimensi " OR ;
     LOWER(SUBS(m.lcRow,m.lii,9))== "dimensio " OR ;
     LOWER(SUBS(m.lcRow,m.lii,10))== "dimension " OR ;
     ((LOWER(SUBS(m.lcRow,m.lii,5))== "decl " OR ;
     LOWER(SUBS(m.lcRow,m.lii,6))== "decla " OR ;
     LOWER(SUBS(m.lcRow,m.lii,7))== "declar " OR ;
     LOWER(SUBS(m.lcRow,m.lii,8))== "declare ") AND ATC(" in ",LOWER(SUBS(m.lcRow,m.lii)))=0));
     ) OR ;
   ((BITTEST(m.liFlags,0) OR BITTEST(m.liFlags,1)) AND (;
     LOWER(SUBS(m.lcRow,m.lii,5))== "arra " OR ;
     LOWER(SUBS(m.lcRow,m.lii,6))== "array "))

   liFlags=BITSET(m.liFlags,6) && Matice
   lii=AT_Word(@lcRow,m.lii+4)
   lcParams=CHRTRAN(SUBS(m.lcRow,m.lii)," "+CHR(9),"")
   RETURN .T.
ENDIF

* Pro seznam vlastnost vra samotn seznam
IF BITTEST(m.liFlags,0) OR BITTEST(m.liFlags,1)
   liFlags=BITSET(m.liFlags,4) && Properties
   lcParams=CHRTRAN(SUBS(m.lcRow,m.lii)," "+CHR(9),"")
   RETURN .T.
ENDIF

* Zatm nic nenael
* pak to otestuj, zda tam nen objekt
IF m.liFlags=0 AND (LOWER(SUBS(m.lcRow,m.lii,4))== "add ")
   lii=AT_NonSpaceEx(@lcRow,m.lii+4,liEnd) && najdi prvn znak

   IF LOWER(SUBS(m.lcRow,m.lii,5))== "obje " OR ;
      LOWER(SUBS(m.lcRow,m.lii,6))== "objec " OR ;
      LOWER(SUBS(m.lcRow,m.lii,7))== "object "

      * Test na objekt - ADD OBJExCT [PROTxECTED/HIDDxEN] name AS class [NOINxIT] [WITH left=5, top=1,...]
      
      * Nastav pznak OBJECT
      liFlags=BITSET(m.liFlags,5)

      * Hledej zda je to PROTECTED nebo HIDDEN
      lii=AT_Word(@lcRow,m.lii+4)

      * Nastav pznak PROTECTED/HIDDEN
      * pokud to nen tento text (proc,proce,proced, ...)
      IF LOWER(SUBS(m.lcRow,m.lii,5))== "prot " OR ;
               LOWER(SUBS(m.lcRow,m.lii,6))== "prote " OR ;
               LOWER(SUBS(m.lcRow,m.lii,7))== "protec " OR ;
               LOWER(SUBS(m.lcRow,m.lii,8))== "protect " OR ;
               LOWER(SUBS(m.lcRow,m.lii,9))== "protecte " OR ;
               LOWER(SUBS(m.lcRow,m.lii,10))=="protected "
               
         liFlags=BITSET(m.liFlags,0)

         lii=AT_Word(@lcRow,m.lii+4)
      ENDIF

      * Nyn by zde ml bt nzev objektu
      liy=AT_SpaceEx(@lcRow,m.lii+1,liEnd) && najdi prvn mezeru

      lcName=SUBS(m.lcRow,m.lii,m.liy-m.lii) && Nati nzev objektu
      lii=AT_NonSpaceEx(@lcRow,m.liy+1,liEnd) && najdi prvn znak

      IF !LOWER(SUBST(m.lcRow,m.lii,3))=="as "
         * Intern chyba, chyb klov slovo AS
         RETURN .F.
      ENDIF
      lii=AT_NonSpaceEx(@lcRow,m.lii+3,liEnd) && najdi prvn znak

      * Nyn by zde ml bt nzev tdy
      STORE AT_SpaceEx(@lcRow,m.lii+1,liEnd) TO liDal,liy && najdi prvn mezeru
      liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)

      lcClass=SUBS(m.lcRow,m.lii,m.liy-m.lii) && Nati nzev tdy
      RETURN .T.
   ENDIF
ENDIF

* Otestuj, zda to nen definice tdy
IF m.liFlags=0 AND;
   (LOWER(SUBS(m.lcRow,m.lii,5))=="defi " OR ;
    LOWER(SUBS(m.lcRow,m.lii,6))=="defin " OR ;
    LOWER(SUBS(m.lcRow,m.lii,7))=="define ")
   * Nzev tdy
*   lii=AT_Word(@lcRow,lii+4)
   lii=AT_SpaceEx(@lcRow,m.lii+4,liEnd) && najdi prvn mezeru
   lii=AT_NonSpaceEx(@lcRow,m.lii,liEnd) && najdi prvn znak po mezee
   IF !LOWER(SUBS(m.lcRow,m.lii,4))=="clas" && pokud to nen tento text
      RETURN .F. && pak vypadni
   ENDIF
   liFlags=BITSET(m.liFlags,11)

   lii=AT_Word(@lcRow,m.lii+4)
*   lii=AT_Space(@lcRow,lii+4) && najdi prvn mezeru
*   lii=AT_NonSpace(@lcRow,lii) && najdi prvn znak po mezee

   STORE AT_SpaceEx(@lcRow,m.lii,liEnd) TO liy,liDal && najdi prvn mezeru (pokud nenael, pak je na konci)
   liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
   lcName=SUBS(m.lcRow,m.lii,m.liy-m.lii)

   IF m.liDal>0
      * Vchoz tda
      lii=AT_NonSpaceEx(@lcRow,m.liy,liEnd) && najdi prvn znak po mezee (Najdi AS)
      lii=AT_SpaceEx(@lcRow,m.lii+2,liEnd) && najdi prvn mezeru ( za AS)

      lii=AT_NonSpaceEx(@lcRow,m.lii+1,liEnd) && najdi prvn znak po mezee (To je patrn potek nzvu tdy)
      STORE AT_SpaceEx(@lcRow,m.lii+1,liEnd) TO liy,liDal && najdi prvn mezeru 
      liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
      lcClass=SUBS(m.lcRow,m.lii,m.liy-m.lii)

      IF m.liDal>0 && Pokud tam jet nco je
         lii=AT_NonSpaceEx(@lcRow,m.liy+1,liEnd) && najdi prvn znak po mezee

         * Pozor, je tam klov slovo OF
         IF LOWER(SUBST(m.lcRow,m.lii,3))=="of "
            liFlags=BITSET(m.liFlags,7) && Nastav pznak
            lii=AT_NonSpaceEx(@lcRow,m.lii+3,liEnd) && najdi prvn znak po mezee (to bude nzev knihovny)
            STORE AT_SpaceEx(@lcRow,m.lii+1,liEnd) TO liDal,liy && najdi prvn mezeru
            liy=IIF(m.liy>0,m.liy,LEN(m.lcRow)+1)
            lcClassLib=LOWER(SUBS(m.lcRow,m.lii,m.liy-m.lii)) && Nzev knihovny
         ENDIF
      ENDIF
   ENDIF
   RETURN .T.
ENDIF

* Otestuj, zda nen konec tdy
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endde " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "enddef " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "enddefi " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "enddefin " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "enddefine" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "enddefin" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "enddefi" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "enddef" OR ;
   LOWER(SUBS(m.lcRow,m.lii))== "endde")

   liFlags=BITSET(m.liFlags,13)
   RETURN .T.
ENDIF

* Pokud je to konec metody/procedury
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endpro " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endproc" OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endpro" OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endfun " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endfunc" OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endfun")
    
   liFlags=BITSET(m.liFlags,12)
   RETURN .T.
ENDIF


* Pokud je to #INCLUDE
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,6))== "#incl " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "#inclu " OR ;
   LOWER(SUBS(m.lcRow,m.lii,8))== "#includ " OR ;
   LOWER(SUBS(m.lcRow,m.lii,9))== "#include ")

   * Nyn lokalizuj soubor
   lii=AT_SpaceEx(@lcRow,m.lii+5,liEnd) && Najdi prvn mezeru
   lii=AT_NonSpaceEx(@lcRow,m.lii,liEnd) && Najdi prvn znak po mezee
   
   lcPom=SUBST(m.lcRow,m.lii,1) && Oddlova ?
   IF m.lcPom="'" OR m.lcPom="[" OR m.lcPom=["]
      liy=RAT_Ex(@lcRow,IIF(m.lcPom="[","]",m.lcPom),m.liLen,1)
      lcClassLib=SUBSTR(m.lcRow,m.lii+1,m.liy-m.lii-1)
   ELSE
      lcClassLib=SUBS(m.lcRow,m.lii)
   ENDIF

   liFlags=BITSET(m.liFlags,14)
   RETURN .T.
ENDIF

* #IF
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,4))== "#if " OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "#ifde " OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "#ifdef ")
   
   liFlags=BITSET(m.liFlags,25)
   RETURN .T.
ENDIF

* TEXT
IF m.liFlags=0 AND LOWER(SUBS(m.lcRow,m.lii,4))== "text" AND EMPTY(SUBS(m.lcRow,m.lii+4,1))
   liFlags=BITSET(m.liFlags,27)
   RETURN .T.
ENDIF

* #ENDIF
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,4))== "#end" OR ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "#endi" OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "#endif")
    
   liFlags=BITSET(m.liFlags,26)
   RETURN .T.
ENDIF

* ENDTEXT
IF m.liFlags=0 AND (;
   LOWER(SUBS(m.lcRow,m.lii,4))== "endt" AND EMPTY(SUBS(m.lcRow,m.lii+4,1)) OR ;
   LOWER(SUBS(m.lcRow,m.lii,5))== "endte" AND EMPTY(SUBS(m.lcRow,m.lii+5,1)) OR ;
   LOWER(SUBS(m.lcRow,m.lii,6))== "endtex" AND EMPTY(SUBS(m.lcRow,m.lii+6,1)) OR ;
   LOWER(SUBS(m.lcRow,m.lii,7))== "endtext" AND EMPTY(SUBS(m.lcRow,m.lii+7,1)))
    
   liFlags=BITSET(m.liFlags,28)
   RETURN .T.
ENDIF

RETURN .T.


*************************************
* Najde oddlova (zleva)
*************************************
PROCEDURE FindMDSC(lcSource,lcOdd,liStart,liEnd)
* @lcSource - Zdrojov etzec
* lcOdd     - Oddlova co se m hledat
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn

LOCAL liFlag,lcChar,liEndFlag

lcChar=SUBS(m.lcSource,m.liStart,1)
liFlag=IIF(m.lcChar="[",1,;
       IIF(m.lcChar="'",2,;
       IIF(m.lcChar='"',4,;
       IIF(m.lcOdd=";",0,;
       IIF(m.lcChar='(',6,0)))))

liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))

DO WHILE m.liStart<=m.liEnd

   IF m.liFlag=0 AND m.lcChar=m.lcOdd
      RETURN m.liStart
   ENDIF

   liStart=m.liStart+1 && Inkrementuj ta
   lcChar=SUBS(m.lcSource,m.liStart,1) && Nati dal znak

   liFlag=IIF(m.liFlag=1 AND m.lcChar="]",0,;
          IIF(m.liFlag=2 AND m.lcChar="'",0,;
          IIF(m.liFlag=4 AND m.lcChar='"',0,;
          IIF(m.liFlag=6 AND m.lcChar=')',0,;
          IIF(m.lcChar="[",1,;
          IIF(m.lcChar="'",2,;
          IIF(m.lcChar='"',4,;
          IIF(m.lcOdd=";",0,;
          IIF(m.lcChar='(',6,m.liFlag)))))))))
ENDDO

RETURN 0 && Vra, e nic nenael

*************************************
* Najde oddlova (zprava)
*************************************
PROCEDURE RFindMDSC(lcSource,lcOdd,liStart,liEnd)
* @lcSource - Zdrojov etzec
* lcOdd     - Oddlova co se m hledat
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn

LOCAL liFlag,lcChar,liEndFlag

lcChar=SUBS(m.lcSource,m.liStart,1)
liFlag=IIF(m.lcChar="]",1,;
       IIF(m.lcChar="'",2,;
       IIF(m.lcChar='"',4,;
       IIF(m.lcOdd=";",0,;
       IIF(m.lcChar=')',6,0)))))

liEnd=IIF(PCOUNT()=4,m.liEnd,1)

DO WHILE m.liStart>=m.liEnd

   IF m.liFlag=0 AND m.lcChar=m.lcOdd
      RETURN m.liStart
   ENDIF

   liStart=m.liStart-1 && Inkrementuj ta
   lcChar=SUBS(m.lcSource,m.liStart,1) && Nati dal znak

   liFlag=IIF(m.liFlag=1 AND m.lcChar="[",0,;
          IIF(m.liFlag=2 AND m.lcChar="'",0,;
          IIF(m.liFlag=4 AND m.lcChar='"',0,;
          IIF(m.liFlag=6 AND m.lcChar='(',0,;
          IIF(m.lcChar="]",1,;
          IIF(m.lcChar="'",2,;
          IIF(m.lcChar='"',4,;
          IIF(m.lcOdd=";",0,;
          IIF(m.lcChar=')',6,m.liFlag)))))))))
ENDDO

RETURN 0 && Vra, e nic nenael


**************************************************************
* Z dku zdrojovho kdu odstran koment a stednk
* a pokud byl stednk ped komentem, pak vrt 1, za komentem 2 a vbec ne 0
****************************************************************
PROCEDURE Trim_SC(lcRow,paComments,lcComment,liIndent)
*@lcRow      - dek zdrojovho kdu
*@paComments - Array of comments
*@lcComment  - Sem vrt koment, je-li
*@liIndent   - Out, Indent
LOCAL lii,liComm,liMD,llComm,lcPom,liDelta,liLen
* Najdi koment

liLen=LEN(m.lcRow)
STORE AT_NonSpaceEx(@lcRow,1,m.liLen) TO liComm
liIndent=liComm-1

IF !ISNULL(paComments)
   FOR lii=1 TO ALEN(paComments)
       IF IIF(UPPER(paComments(lii))=="NOTE" ,;
             LOWER(SUBS(m.lcRow,m.liComm,LEN(paComments(lii))+1))==paComments(lii)+" ",;
             LOWER(SUBS(m.lcRow,m.liComm,LEN(paComments(lii))))==paComments(lii))
          liDelta=LEN(paComments(lii))
          EXIT
       ENDIF
   NEXT
ELSE
   lii=2
ENDIF

IF m.lii>ALEN(paComments)
   liComm=AT("&"+"&",m.lcRow)
   liDelta=IIF(m.liComm>0,2,0)
ENDIF


IF m.liComm>0
   liMD=RAT_NonSpaceEx(@lcRow,m.liLen,m.liComm)
   llComm=SUBS(m.lcRow,m.liMD,1)=";"
ENDIF

lcComment=IIF(PCOUNT()>=3 AND m.liComm>0,;
          IIF(m.liMD=0 OR !m.llComm,SUBS(m.lcRow,m.liComm+m.liDelta),SUBS(m.lcRow,m.liComm+m.liDelta,m.liMD-(m.liComm+m.liDelta))),;
          "") && Vra koment

lii=RAT_NonSpaceEx(@lcRow,IIF(m.liComm>0,m.liComm-1,m.liLen),1)
lii=IIF(SUBS(m.lcRow,m.lii,1)=";",m.lii,0)

lcRow=IIF(m.liComm>0,LEFT(m.lcRow,IIF(m.lii=0,m.liComm,lii)-1),;
          IIF(m.lii=0,m.lcRow,LEFT(m.lcRow,m.lii-1)))

RETURN IIF(m.liComm>0,IIF(m.lii>0,1,IIF(m.llComm,2,0)),;
       IIF(m.lii>0,1,0))

*******************************************************************
