LPARAM lcType,lcSL,lcDL,llAddLost,llShowSame
*lcType    - GUI, HTML, PDM
*lcSL      - Source language file
*lcDL      - Destination language file
*llAddLost - Add lost string to destination table
*llShowSame - Show Same string from destination table

*****************************************************************
** Program name: synstring.PRG
** Version: 0.1
** Create date: 2004-06-12
** Description: Synchronize strings from source language table with destination language table
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** CP: 1250

** All warnings shows in Debug Output

** Using:
** ------
** 
** Synchrononize French language with English language for HTML
** English language - source, French language - destination
** DO synstring with "HTML","EN", "FR", .F. , .F. && Show lost strings, don't show the same strings
** DO synstring with "HTML","EN", "FR", .F. , .T. && Show lost strings, show the same strings
**
** DO synstring with "HTML","EN", "FR", .T. , .F. && Show lost strings and add it to destibation table, don't show the same strings
** DO synstring with "HTML","EN", "FR", .T. , .T. && Show lost strings and add it to destibation table, show the same strings

** Synchrononize French language with English language for GUI
** English language - source, French language - destination
** DO synstring with "GUI","EN", "FR", .F. , .F. && Show lost strings, don't show the same strings
** DO synstring with "GUI","EN", "FR", .F. , .T. && Show lost strings, show the same strings
**
** DO synstring with "GUI","EN", "FR", .T. , .F. && Show lost strings and add it to destibation table, don't show the same strings
** DO synstring with "GUI","EN", "FR", .T. , .T. && Show lost strings and add it to destibation table, show the same strings

** Synchrononize other languages with English language for HTML
** English language - source
** DO synstring with "HTML","EN", "", .F. , .F. && Show lost strings, don't show the same strings
** DO synstring with "HTML","EN", "", .F. , .T. && Show lost strings, show the same strings
**
** DO synstring with "HTML","EN", "", .T. , .F. && Show lost strings and add it to destibation table, don't show the same strings
** DO synstring with "HTML","EN", "", .T. , .T. && Show lost strings and add it to destibation table, show the same strings

** Synchrononize other languages with English language for GUI
** English language - source
** DO synstring with "GUI","EN", "", .F. , .F. && Show lost strings, don't show the same strings
** DO synstring with "GUI","EN", "", .F. , .T. && Show lost strings, show the same strings
**
** DO synstring with "GUI","EN", "", .T. , .F. && Show lost strings and add it to destibation table, don't show the same strings
** DO synstring with "GUI","EN", "", .T. , .T. && Show lost strings and add it to destibation table, show the same strings


LOCAL lcPath,lcFileS,lcFileD,lcSA,lcDA,liXX000,lcXX001,lii,liCount,liy
LOCAL ARRAY laLang(1),laDir(1)
lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

lcPath=lcPath+IIF(lcType=="HTML" OR lcType=="PDM","lang\","gui\lang\")

lcFileS=lcPath+IIF(lcType=="HTML",ALLT(lcSL)+"\html.dbf",ALLT(lcSL)+"\pdm.dbf")

lcSA=SYS(2015)
lcDA=SYS(2015)

IF !OpenTable(lcFileS,lcSA," SHARE ORDER XXI000")
   =MESSAGEBOX("Cannot open file "+lcFileS+".")
   RETURN
ENDIF

IF EMPTY(lcDL)
   liCount=ADIR(laDir,lcPath+"*.*","ASHRD")

   DIME lalang(liCount)
   liy=0
   FOR lii=1 TO liCount
       IF AT("D",laDir(lii,5))>0 AND !(laDir(lii,1)=="." OR laDir(lii,1)==".." OR LOWER(laDir(lii,1))=LOWER(ALLT(lcSL)))
          liy=liy+1
          laLang(liy)=laDir(lii,1)
       ENDIF
   NEXT

   IF liy>0
      DIME laLang(liy)
   ELSE
      =MESSAGEBOX("No language.")
      USE IN (lcSA)
      RETURN
   ENDIF
ELSE
   laLang(1)=ALLT(lcDL)
   liy=1
ENDIF


llShowSame=IIF(PCOUNT()<5,.T.,llShowSame)

FOR lii=1 TO liy
    lcFileD=lcPath+IIF(lcType=="HTML",laLang(lii)+"\html.dbf",laLang(lii)+"\pdm.dbf")

    IF !OpenTable(lcFileD,lcDA," SHARE ORDER XXI000")
       =MESSAGEBOX("Cannot open file "+lcFileD+".")
       RETURN
    ENDIF
    debugout "************************"
    debugout lcFileD

    SELE (lcSA)
    SCAN ALL
         liXX000=XX000
         lcXX001=XX001
         SELE (lcDA)
         IF !SEEK(liXX000)
            debugout "Lost"+STR(liXX000,11)+" "+lcXX001
            IF llAddLost
               INSER INTO (lcDA) (XX000,XX001) VALUES (liXX000,lcXX001)
            ENDIF
            LOOP
         ENDIF

         IF lcXX001==XX001 AND llShowSame
            debugout "The same"+STR(liXX000,11)+" "+lcXX001
         ENDIF
         SELE (lcSA)
    ENDSCAN
    USE IN (lcDA)
NEXT
USE IN (lcSA)

********************************************
PROCEDURE OpenTable(lcFile,lcAlias,lcParam)
LOCAL llErr,lcErr
lcErr=ON("ERROR")
ON ERROR llErr=.T.
USE (lcFile) ALIAS (lcAlias) &lcParam. IN 0

IF EMPTY(lcErr)
   ON ERROR
ELSE
   ON ERROR &lcErr.
ENDIF
RETURN !llErr